package soundmeterwrapper;

import me.daei.soundmeter.widget.SoundDiscView;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
//import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Permissions;

import anywheresoftware.b4a.BA.Events;
//import android.view.MotionEvent;

//import android.graphics.Color;
//import android.graphics.Typeface;

import android.view.View;
import android.widget.TextView;
import android.widget.ImageView;
//import android.view.Gravity; 

//import android.util.Log;
//import android.view.ViewTreeObserver;

//import android.media.AudioFormat;
//import android.media.AudioRecord;
//import android.media.MediaRecorder;

import java.util.ArrayList;
import java.util.List;
//import java.util.Timer;
//import java.util.TimerTask;

//import android.os.Build;
import android.os.Bundle;
import android.widget.FrameLayout;


import android.os.Handler;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.view.MotionEvent;
import android.view.View.OnTouchListener;


import android.widget.Toast;
import android.view.Gravity;
import android.graphics.drawable.BitmapDrawable;

import me.daei.soundmeter.MyMediaRecorder;
import android.os.Handler;
import android.os.Message;
import me.daei.soundmeter.World;
import android.util.Log;
import java.io.File;
import me.daei.soundmeter.FileUtil;




@ActivityObject
@Events(values={"value_changed(data As Float)"})
@Author("Github: halibobo, Wrapped by: Johan Schoeman")
//@Version(1.00f)
@ShortName("SoundMeter")
@DependsOn(values={"com.android.support:appcompat-v7", "com.android.support:support-v4"})
@Permissions(values={"android.permission.WRITE_EXTERNAL_STORAGE","android.permission.RECORD_AUDIO"})
public class soundmeterWrapperEmbedded extends ViewWrapper<SoundDiscView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
    private SoundDiscView cv;
	private MyMediaRecorder mRecorder;
	private static final int refreshTime = 100;
	private static final int msgWhat = 0x1001;
	float volume = 10000;
	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new SoundDiscView(ba.context);
        this.setObject(cv);
		mRecorder = new MyMediaRecorder();
 	}
	
	public void setBackgroundImage(BitmapDrawable img) {
		cv.setBackgroundDrawable(img);
		cv.invalidate();
	}
	
	private float myvalue = 0.0f;
    private Handler handler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            if (this.hasMessages(msgWhat)) {
                return;
            }
            volume = mRecorder.getMaxAmplitude();  
            if(volume > 0 && volume < 1000000) {
                World.setDbCount(20 * (float)(Math.log10(volume)));  
                cv.refresh();
				myvalue = 20 * (float)(Math.log10(volume));
                //if (ba.subExists(eventName + "_value_changed")) {
				//  ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_value_changed", true, new Object[] {20 * (float)(Math.log10(volume))});
                //}				
            }
            handler.sendEmptyMessageDelayed(msgWhat, refreshTime);
        }
    };

    private void startListenAudio() {
        handler.sendEmptyMessageDelayed(msgWhat, refreshTime);
    }	
	

    private void startRecord(File fFile){
        try{
            mRecorder.setMyRecAudioFile(fFile);
            if (mRecorder.startRecorder()) {
                startListenAudio();
            }else{
                Toast.makeText(ba.applicationContext, "Failed to start recording", Toast.LENGTH_SHORT).show();
            }
        }catch(Exception e){
            Toast.makeText(ba.applicationContext, "Recorder is already occupied or recording permission is forbidden", Toast.LENGTH_SHORT).show();
            e.printStackTrace();
        }
    }

    public void StartdB() {
        File file = FileUtil.createFile("temp.amr");
        if (file != null) {
            Log.v("file", "file =" + file.getAbsolutePath());
            startRecord(file);
        } else {
            Toast.makeText(ba.applicationContext, "Failed to create file", Toast.LENGTH_LONG).show();
        }
    }	
	

    public void StopdB() {
        mRecorder.delete(); 
        handler.removeMessages(msgWhat);
    }
	
	public float getdBValue() {
		return myvalue;
	}

	

/*     private void addListener1() {
        cv.setImageListener(imageListener);
		
        cv.setImageClickListener(new ImageClickListener() {
            @Override
            public void onClick(int position) {
                //Toast.makeText(ba.applicationContext, "Clicked item: "+ position, Toast.LENGTH_SHORT).show();
            }
        });		
//        cv.setViewListener(mViewListener);		
	}	 */
	

	
/*     ViewListener viewListener = new ViewListener() {
        @Override
        public View setViewForPosition(int position) {

            View customView = getLayoutInflater().inflate(R.layout.view_custom, null);

            TextView labelTextView = (TextView) customView.findViewById(R.id.labelTextView);
            ImageView fruitImageView = (ImageView) customView.findViewById(R.id.fruitImageView);

            fruitImageView.setImageResource(sampleImages[position]);
            labelTextView.setText(sampleTitles[position]);

            carouselView.setIndicatorGravity(Gravity.CENTER_HORIZONTAL|Gravity.TOP);

            return customView;
        }
    };	 */
	
//    private List<Object> bImage;
//    public void setImageBitmaps(List<Object> bImage) {
//        this.bImage = bImage;
//		cv.setPageCount(bImage.size());
        //if (ba.subExists(eventName + "_picture_changed")) {
        //  ba.raiseEvent2(ba, false, eventName + "_picture_changed", true, new Object[]{0});
        //}		
//    }	
	
/* 	ImageListener imageListener = new ImageListener() {
        @Override
        public void setImageForPosition(int position, ImageView imageView) {
            //if (ba.subExists(eventName + "_current_position")) {
            //  ba.raiseEvent2(ba, false, eventName + "_current_position", true, new Object[] {position});
            //}
			imageView.setImageBitmap((Bitmap) bImage.get(position));	
        }
    };
 */




/*     public void setBackground(Drawable background) {
        super.setBackground(background);
    }

    public Drawable getIndicatorBackground() {
        return mIndicator.getBackground();
    } */

	
	

/*     View.OnClickListener pauseOnClickListener = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            BA.Log("HIER");
        }
    };	
 */	
 
 
/*  yourRelativeLayout.setOnTouchListener(new View.OnTouchListener() {  
    @Override
    public boolean onTouch(View arg0, MotionEvent arg1) {
        //gesture detector to detect swipe.
        gestureDetector.onTouchEvent(arg1);
        return true;//always return true to consume event
    }
});
 */	
 
 
/*  	private void addListener2() {
		cv.setOnTouchListener(new View.OnTouchListener() {
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				BA.Log("GOT HERE");
				if(event.getAction() == MotionEvent.ACTION_UP){

					BA.Log("up");
					return true;
				}
				return true;
			}
		});
	}
 */ 	
	
/*     @Override
    public boolean onTouch(View v, MotionEvent event) {

        //int action = event.getAction();
        switch (event.getAction()){
        case MotionEvent.ACTION_DOWN:
            BA.Log("DOWN");
        break;

        case MotionEvent.ACTION_MOVE:
            BA.Log("MOVE");
        break;

        case MotionEvent.ACTION_UP:
            BA.Log("UP");


        break;
        }
        return true;
    }
 */	
	
	
	
	
		
/*     private void addListener2() {
		//BA.Log("addListener2");
		cv.setOnClickListener(new View.OnClickListener() {

			volatile int i = 0;

			@Override
			public void onClick(View v) {
                BA.Log("in onClick");
				i++;
				Handler handler = new Handler();

				Runnable r = new Runnable() {
					@Override
					public void run() {
						if (i == 1) {
              if (ba.subExists(eventName + "_single_click")) {
                ba.raiseEvent2(ba, false, eventName + "_single_click", true, new Object[0]);
              }
						}
					}
				};

				if (i == 1) {
					handler.postDelayed(r, 150);
				} else if (i == 2) {
					handler.removeCallbacks(r);
					i = 0;
              if (ba.subExists(eventName + "_double_click")) {
                //ba.raiseEvent2(ba, false, eventName + "_double_click", true, new Object[0]);
				ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_double_click", true, new Object[0]);
              }
				}
			}
		}
		);		
    }
	 */
	 
	 
	

	
	
	
    // To set custom views
//    ViewListener viewListener = new ViewListener() {
//        @Override
//        public void setViewForPosition(int position) {

//			if (ba.subExists(eventName + "_current_position")) {
//			  ba.raiseEvent2(ba, false, eventName + "_current_position", true, new Object[] {position});
//			}
//        }
//    };	
	  
	 


//     private void addListener() {
//        cv.setOnProgressTrackListener(new OnProgressTrackListener() {
//            @Override
//            public void onProgressFinish() {
//              if (ba.subExists(eventName + "_progress_completed")) {
//                ba.raiseEvent2(ba, false, eventName + "_progress_completed", true, new Object[0]);
//              }
//            }
//            @Override
//            public void onProgressUpdate(int progress) {
//              if (ba.subExists(eventName + "_progress_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_progress_changed", true, new Object[]{progress});
//              }
//            }
//        });
//    }



//          public void addListener2() {
//            ViewTreeObserver observer = cv.getViewTreeObserver();
//            observer.addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {
//                @Override
//                public void onGlobalLayout() {
//                    cv.setBaseY(cv.getHeight());
//                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN) {
//                        cv.getViewTreeObserver().removeOnGlobalLayoutListener(this);
//                    } else {
//                        cv.getViewTreeObserver().removeGlobalOnLayoutListener(this);
//                    }
//                }
//            });
//          }




/*     @Hide
    public void addListener3(){

        cv.setCallback(new CarouselView.Callback() {
            @Override
            public void picture_changed() {

              if (ba.subExists(eventName + "_picture_changed")) {
                ba.raiseEvent2(ba, false, eventName + "_picture_changed", true, new Object[]{cv.getCurrentPosition()});
              }
            }

             @Override
            public void scroll_stopped() {

              if (ba.subExists(eventName + "_scroll_stopped")) {
                ba.raiseEvent2(ba, false, eventName + "_scroll_stopped", true, new Object[0]);
              }
            }
			
            @Override
            public void picture_touched() {

              if (ba.subExists(eventName + "_picture_touched")) {
                ba.raiseEvent2(ba, false, eventName + "_picture_touched", true, new Object[]{cv.getCurrentPosition()});
              }
            }	

            @Override
            public void picture_long_touched() {

              if (ba.subExists(eventName + "_picture_long_touched")) {
                ba.raiseEvent2(ba, false, eventName + "_picture_long_touched", true, new Object[]{cv.getCurrentPosition()});
              }
            }				 
			
			
        });
    }  */

	
  
	

    
//    public void addImage(String draw) {
//		 int DrawableID = BA.applicationContext.getResources().getIdentifier(draw, "drawable", BA.packageName);
//               cv.setForeground(DrawableID);
//		 Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
//                 cv.setForeground(drawable); 
//    }


	
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	
	
	
	
	
	
/*     public void setImageListener(ImageListener mImageListener) {
        this.mImageListener = mImageListener;
    }

    public void setViewListener(ViewListener mViewListener) {
        this.mViewListener = mViewListener;
    } */

//    public int getPageCount() {
//        return mPageCount;
//    }

/*     public void setPageCount(int mPageCount) {
        cv.setPageCount(mPageCount);
        cv.invalidate();
    } */

//    public void addOnPageChangeListener(ViewPager.OnPageChangeListener listener) {
//        containerViewPager.addOnPageChangeListener(listener);
//    }

/*     public void setCurrentItem(int item) {
        cv.setCurrentItem(item);
		cv.invalidate();
    } */

//    public int getPosition() {
//        return mPosition;
//    }

//    public void setPosition(int position) {
//        cv.setPosition(position);
//		cv.invalidate();
//    }


//    public int getOrientation() {
//        return mIndicator.getOrientation();
//    }

//    public int getFillColor() {
//        return mIndicator.getFillColor();
//    }

//    public int getStrokeColor() {
//        return mIndicator.getStrokeColor();
//    }

/*     public void setSnap(boolean snap) {
        cv.setSnap(snap);
		cv.invalidate();
    }

    public void setRadius(float radius) {
        cv.setRadius(radius);
		cv.invalidate();
    } */

//    public float getStrokeWidth() {
//        return mIndicator.getStrokeWidth();
//    }

//    public void setBackground(Drawable background) {
//        super.setBackground(background);
//    }


/*     public void setFillColor(int fillColor) {
        cv.setFillColor(fillColor);
		cv.invalidate();
    }


    public void setOrientation(int orientation) {
        cv.setOrientation(orientation);
		cv.invalidate();
    } */

//    public boolean isSnap() {
//        return cv.isSnap();
//    }

/*     public void setStrokeColor(int strokeColor) {
        cv.setStrokeColor(strokeColor);
		cv.invalidate();
    }


    public void setPageColor(int pageColor) {
        cv.setPageColor(pageColor);
		cv.invalidate();
    }

    public void setStrokeWidth(float strokeWidth) {
        cv.setStrokeWidth(strokeWidth);
		cv.invalidate();
    } */

    /**
     * Starts auto scrolling if
     */
/*     public void playCarousel() {
        cv.playCarousel();
		cv.invalidate();
    } */

    /**
     * Stops auto scrolling.
     */
/*     public void pauseCarousel() {
        cv.pauseCarousel();
		cv.invalidate();
    } */


    /**
     * Set interval for one slide in milliseconds.
     *
     * @param slideInterval milliseconds
     */
/*     public void setSlideInterval(int slideInterval) {
        cv.setSlideInterval(slideInterval);
		cv.invalidate();
    }
 */
    /**
     * Set interval for one slide in milliseconds.
     *
     * @param slideInterval milliseconds
     */
//   public void reSetSlideInterval(int slideInterval) {
//       cv.reSetSlideInterval(slideInterval);
//		cv.invalidate();
//    }

//    public boolean isAutoPlay() {
//        return cv.isAutoPlay();
//    }

/*     public void setAutoPlay(boolean autoPlay) {
        cv.setAutoPlay(autoPlay);
    } */

//    public boolean isDisableAutoPlayOnUserInteraction() {
//        return cv.isDisableAutoPlayOnUserInteraction();
//    }

/*     public void setDisableAutoPlayOnUserInteraction(boolean disableAutoPlayOnUserInteraction) {
        cv.setDisableAutoPlayOnUserInteraction(disableAutoPlayOnUserInteraction);
		cv.invalidate();
    } */

//    public void setData() {
//        cv.setData();
//		cv.invalidate();
//    }	
	
	


/*     Callback callback;
    public interface  Callback{
        void picture_changed();
		void scroll_stopped();
		void picture_touched();
		void picture_long_touched();
    }

    private void invokePictureChanged() {
        if(callback!=null){
            callback.picture_changed();
        }
    }
	
    private void invokeUserScrollStopped() {
        if(callback!=null){
            callback.scroll_stopped();
        }
    }	
	
    private void invokePictureTouched() {
        if(callback!=null){
            callback.picture_touched();
        }
    }	

    private void invokePictureLongTouched() {
        if(callback!=null){
            callback.picture_long_touched();
        }
    }			


    public void setCallback(Callback callback){
        this.callback = callback;
    }	
	
 */	
	

   
}
